Project Chrono: chrono::vehicle::NonlinearSpringDamperTorque Class Reference

Public Member Functions | List of all members
chrono::vehicle::NonlinearSpringDamperTorque Class Reference
VEHICLE module

## Description

Utility class for specifying a nonlinear rotational spring-damper torque.

`#include <ChSubsysDefs.h>`

Inheritance diagram for chrono::vehicle::NonlinearSpringDamperTorque:
[legend]
Collaboration diagram for chrono::vehicle::NonlinearSpringDamperTorque:
[legend]

## Public Member Functions
| NonlinearSpringDamperTorque (double preload=0)
| NonlinearSpringDamperTorque (const std::vector< std::pair< double, double > > &dataK, const std::vector< std::pair< double, double > > &dataC, double preload=0)
void | add_pointK (double x, double y)
void | add_pointC (double x, double y)
virtual double | evaluate (double time, double rest_angle, double angle, double vel, const ChLinkRSDA &link) override
| Calculate and return the general spring-damper torque at the specified configuration.
virtual rapidjson::Value | exportJSON (rapidjson::Document::AllocatorType &allocator) override
| Optional reporting function to generate a JSON value with functor information.

## Member Function Documentation

## ◆ evaluate()

double chrono::vehicle::NonlinearSpringDamperTorque::evaluate | ( | double | time,
|  | double | rest_angle,
|  | double | angle,
|  | double | vel,
|  | const ChLinkRSDA & | link )
| overridevirtual

Calculate and return the general spring-damper torque at the specified configuration.

Parameters

  time | current time
  rest_angle | undeformed angle
  angle | relative angle of rotation
  vel | relative angular speed
  link | associated RSDA link

Implements chrono::ChLinkRSDA::TorqueFunctor.

## ◆ exportJSON()

rapidjson::Value chrono::vehicle::NonlinearSpringDamperTorque::exportJSON | ( | rapidjson::Document::AllocatorType & | allocator | ) |
| overridevirtual

Optional reporting function to generate a JSON value with functor information.

Reimplemented from chrono::ChLinkRSDA::TorqueFunctor.

The documentation for this class was generated from the following files:

- D:/W/B/src/chrono-9.0.1/src/chrono_vehicle/ChSubsysDefs.h
- D:/W/B/src/chrono-9.0.1/src/chrono_vehicle/ChSubsysDefs.cpp